/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 12 octobre 2006
   derniere modification le 10/07/2007 */


#ifndef __SCENGINE_H__
#define __SCENGINE_H__


#include <SCE/SCEMinimal.h>


/* inclusions des en-tetes de manipulations mathematiques */
#include <SCE/utils/SCEMath.h>
#include <SCE/utils/SCEVector.h>
#include <SCE/utils/SCEMatrix.h>

/* outils */
#include <SCE/utils/SCEInert.h>

/* inclusion du coeur */
#include <SCE/core/SCECore.h>

/* inclusion des modules principaux */
#include <SCE/interface/SCEMedia.h>
#include <SCE/interface/SCEResources.h>
#include <SCE/interface/SCEMesh.h>

/* gestionnaires "bas niveau" */
#include <SCE/interface/SCETexture.h>
#include <SCE/interface/SCEShaders.h>
#include <SCE/interface/SCEMaterial.h>

/* gestionnaires "haut niveau" */
#include <SCE/interface/SCEModel.h>
#include <SCE/interface/SCECamera.h>
#include <SCE/interface/SCESkybox.h>
/*#include <SCE/interface/SCEScene.h>*/



/* initialise le SCEngine */
int SCE_Init(FILE*, SCEflags);


/* quitte le SCEngine */
int SCE_Quit(void);


#endif /* guard */
