/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 21 decembre 2006
   derniere modification le 23/06/2007 */


#ifndef __SCEMATRIX_H__
#define __SCEMATRIX_H__

typedef float SCE_TMatrix4[16];

void SCE_Matrix4_LoadIdentity(SCE_TMatrix4);

void SCE_Matrix4_Mul(SCE_TMatrix4, SCE_TMatrix4);

void SCE_Matrix4_Add(SCE_TMatrix4, SCE_TMatrix4);

void SCE_Matrix4_Sub(SCE_TMatrix4, SCE_TMatrix4);

void SCE_Matrix4_Transpose(SCE_TMatrix4);

void SCE_Matrix4_RotX(SCE_TMatrix4, float);

void SCE_Matrix4_RotY(SCE_TMatrix4, float);

void SCE_Matrix4_RotZ(SCE_TMatrix4, float);

void SCE_Matrix4_Rotatev(SCE_TMatrix4, float, SCE_TVector3);

void SCE_Matrix4_Rotate(SCE_TMatrix4, float, float, float, float);

void SCE_Matrix4_MulV3(SCE_TMatrix4, SCE_TVector3);

#endif /* guard */
